var gulp        = require('gulp');
var browserSync = require('browser-sync').create();
var sass        = require('gulp-sass');
var cssmin = require('gulp-minify-css');
var reload      = browserSync.reload;
var spritesmith = require('gulp.spritesmith');
var autoprefixer = require('gulp-autoprefixer');

// 静态服务器 + 监听 scss/html 文件
gulp.task('serve', ['sass'], function() {
    var files = [
        '*.html',
        './html/*.html',
        './css/*.css',
        './scss/*.scss',
        './base/*.scss',
        './images/*.png',
        './js/*.js'
    ];

//  browserSync.init(files, {
//      server: {
//          baseDir: './'
//      },
//      open: 'external',
//      startPath: "./index.html"
//  });

    gulp.watch('./**/*.scss', ['sass']).on('change', reload);
    gulp.watch("*/**/*.html").on('change', reload);
    gulp.watch("*/images/*.png").on('change', reload);
});

// scss编译后的css将注入到浏览器里实现更新
gulp.task('sass', function() {
    return gulp.src('./scss/**/*.scss')
        .pipe(sass().on('error', sass.logError))
        .pipe(gulp.dest('./css'))
        .pipe(reload({stream: true}));
});


 
gulp.task('autoprefixer', function () {
    return gulp.src('./css/*.css')
        .pipe(autoprefixer({
            browsers: ['last 2 versions', 'Android >= 4.0'],
            cascade: true, //是否美化属性值 默认：true 像这样：
            remove:true //是否去掉不必要的前缀 默认：true 
        }))
        .pipe(gulp.dest('dist/css'));
});

gulp.task('minify', function() {
    return gulp.src('css/**.css')
        .pipe(cssmin())
        .pipe(gulp.dest('./css'));
});


gulp.task('spritesmith', function () {
    return gulp.src('images/icon/*.png')//需要合并的图片地址
        .pipe(spritesmith({
            imgName: 'images/sprite.png',//保存合并后图片的地址
            cssName: 'css/sprite.css',//保存合并后对于css样式的地址
            padding:2,//合并时两个图片的间距
            algorithm: 'binary-tree',//注释1
        }))
        .pipe(gulp.dest('./'));
});



gulp.task('default', ['serve', 'autoprefixer', 'minify']);
